require 'test/unit'
require File.dirname(__FILE__) + '/../lib/staticmatic'

class StaticMaticVersionTest < Test::Unit::TestCase
  def setup
    @base_dir = File.dirname(__FILE__) + '/sandbox/tmp'
  end

  def test_version_requirements_met
    assert_equal true, StaticMatic::VERSION.requirements_met?

    assert_equal false, StaticMatic::VERSION.requirements_met?("#{StaticMatic::VERSION::MAJOR+1}.0.0")
    assert_equal false, StaticMatic::VERSION.requirements_met?("#{StaticMatic::VERSION::MAJOR}.#{StaticMatic::VERSION::MINOR+1}.0")
    assert_equal false, StaticMatic::VERSION.requirements_met?("#{StaticMatic::VERSION::MAJOR}.#{StaticMatic::VERSION::MINOR}.#{StaticMatic::VERSION::TINY+1}")
    assert_equal true, StaticMatic::VERSION.requirements_met?("#{StaticMatic::VERSION::MAJOR-1}.9999.9999")
    assert_equal true, StaticMatic::VERSION.requirements_met?("#{StaticMatic::VERSION::MAJOR}.#{StaticMatic::VERSION::MINOR-1}.9999")
    assert_equal true, StaticMatic::VERSION.requirements_met?("#{StaticMatic::VERSION::MAJOR}.#{StaticMatic::VERSION::MINOR}.#{StaticMatic::VERSION::TINY-1}")
    assert_equal true, StaticMatic::VERSION.requirements_met?("#{StaticMatic::VERSION::MAJOR}.#{StaticMatic::VERSION::MINOR}.#{StaticMatic::VERSION::TINY}")

    assert_equal false, StaticMatic::VERSION.requirements_met?(:major => StaticMatic::VERSION::MAJOR+1)
    assert_equal false, StaticMatic::VERSION.requirements_met?(:major => StaticMatic::VERSION::MAJOR, :minor => StaticMatic::VERSION::MINOR+1)
    assert_equal false, StaticMatic::VERSION.requirements_met?(:major => StaticMatic::VERSION::MAJOR, :minor => StaticMatic::VERSION::MINOR, :tiny => StaticMatic::VERSION::TINY+1)
    assert_equal true, StaticMatic::VERSION.requirements_met?(:major => StaticMatic::VERSION::MAJOR-1, :minor => 9999, :tiny => 9999)
    assert_equal true, StaticMatic::VERSION.requirements_met?(:major => StaticMatic::VERSION::MAJOR, :minor => StaticMatic::VERSION::MINOR-1, :tiny => 9999)
    assert_equal true, StaticMatic::VERSION.requirements_met?(:major => StaticMatic::VERSION::MAJOR, :minor => StaticMatic::VERSION::MINOR, :tiny => StaticMatic::VERSION::TINY-1)
    assert_equal true, StaticMatic::VERSION.requirements_met?(:major => StaticMatic::VERSION::MAJOR, :minor => StaticMatic::VERSION::MINOR, :tiny => StaticMatic::VERSION::TINY)
  end
end
